
_Main_Init:

;electronique_interface_midi_010_16f628.mpas,75 :: 		begin
;electronique_interface_midi_010_16f628.mpas,76 :: 		CMCON := 7;            // disable comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_interface_midi_010_16f628.mpas,77 :: 		OPTION_REG := 0;       // enable pullup on portB
	CLRF       OPTION_REG+0
;electronique_interface_midi_010_16f628.mpas,78 :: 		INTCON.GIE := 1;       // |- enable interrupt
	BSF        INTCON+0, 7
;electronique_interface_midi_010_16f628.mpas,79 :: 		INTCON.PEIE := 1;      // |
	BSF        INTCON+0, 6
;electronique_interface_midi_010_16f628.mpas,80 :: 		TRISA      := %11100000;
	MOVLW      224
	MOVWF      TRISA+0
;electronique_interface_midi_010_16f628.mpas,81 :: 		TRISB      := %00000010;
	MOVLW      2
	MOVWF      TRISB+0
;electronique_interface_midi_010_16f628.mpas,82 :: 		PORTA      := 0;  // clear porta
	CLRF       PORTA+0
;electronique_interface_midi_010_16f628.mpas,83 :: 		PORTB      := 0;  // clear portb
	CLRF       PORTB+0
;electronique_interface_midi_010_16f628.mpas,84 :: 		T1CON.T1CKPS1 := 1;
	BSF        T1CON+0, 5
;electronique_interface_midi_010_16f628.mpas,85 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_010_16f628.mpas,87 :: 		TXSTA.SYNC := 0;     // asynchronous mode
	BCF        TXSTA+0, 4
;electronique_interface_midi_010_16f628.mpas,88 :: 		TXSTA.TX9 := 0;      // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_interface_midi_010_16f628.mpas,89 :: 		TXSTA.TXEN := 1;     // Tx enabled
	BSF        TXSTA+0, 5
;electronique_interface_midi_010_16f628.mpas,90 :: 		RCSTA.CREN := 1;     // enable receiving / accept continuous mode
	BSF        RCSTA+0, 4
;electronique_interface_midi_010_16f628.mpas,91 :: 		RCSTA.SPEN := 1;     // Rx enabled;
	BSF        RCSTA+0, 7
;electronique_interface_midi_010_16f628.mpas,92 :: 		RCSTA.RX9 := 0;      // 8-bits transmission
	BCF        RCSTA+0, 6
;electronique_interface_midi_010_16f628.mpas,93 :: 		PIE1.RCIE := 1;      // enable interrupt for UART Rx
	BSF        PIE1+0, 5
;electronique_interface_midi_010_16f628.mpas,96 :: 		Out_Led := 1;
	BSF        RA4_bit+0, 4
;electronique_interface_midi_010_16f628.mpas,97 :: 		Out_Spi_Data := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_010_16f628.mpas,98 :: 		Out_Spi_Clock := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_010_16f628.mpas,100 :: 		UART1_Init(cMidiBaudrate); // speed for MIDI communication
	MOVLW      15
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_interface_midi_010_16f628.mpas,102 :: 		Delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__Main_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init1
	NOP
;electronique_interface_midi_010_16f628.mpas,103 :: 		SetBit(RCSTA,CREN);  // enable receiver
	BSF        RCSTA+0, 4
;electronique_interface_midi_010_16f628.mpas,106 :: 		Memset(@ArrRxBuf, 0, cRxBufSize);
	MOVLW      _ArrRxBuf+0
	MOVWF      FARG_memset_p+0
	CLRF       FARG_memset_character+0
	MOVLW      64
	MOVWF      FARG_memset_n+0
	CLRF       FARG_memset_n+1
	CALL       _memset+0
;electronique_interface_midi_010_16f628.mpas,107 :: 		iRxHead     := 0;
	CLRF       _iRxHead+0
;electronique_interface_midi_010_16f628.mpas,108 :: 		iRxTail     := 0;
	CLRF       _iRxTail+0
;electronique_interface_midi_010_16f628.mpas,109 :: 		bRxBufFull  := false ;
	CLRF       _bRxBufFull+0
;electronique_interface_midi_010_16f628.mpas,110 :: 		bRxBufEmpty := true;
	MOVLW      255
	MOVWF      _bRxBufEmpty+0
;electronique_interface_midi_010_16f628.mpas,111 :: 		iCounter    := 0;
	CLRF       _iCounter+0
;electronique_interface_midi_010_16f628.mpas,113 :: 		end;
L_end_Main_Init:
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_interface_midi_010_16f628.mpas,116 :: 		begin
;electronique_interface_midi_010_16f628.mpas,118 :: 		if PIR1.RCIF = 1 then
	BTFSS      PIR1+0, 5
	GOTO       L__Interrupt4
;electronique_interface_midi_010_16f628.mpas,120 :: 		iRxStatus := RCSTA; // Error-handling
	MOVF       RCSTA+0, 0
	MOVWF      _iRxStatus+0
;electronique_interface_midi_010_16f628.mpas,123 :: 		iRxData := RCREG;
	MOVF       RCREG+0, 0
	MOVWF      _iRxData+0
;electronique_interface_midi_010_16f628.mpas,127 :: 		if (iRxStatus and %00000110) = 0 then
	MOVLW      6
	ANDWF      _iRxStatus+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt7
;electronique_interface_midi_010_16f628.mpas,129 :: 		if (not bRxBufFull) then       // if buffer full, do nothing
	COMF       _bRxBufFull+0, 0
	MOVWF      R0+0
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt10
;electronique_interface_midi_010_16f628.mpas,132 :: 		if (iRxData <> cMIDI_Active_Sensing) then
	MOVF       _iRxData+0, 0
	XORLW      254
	BTFSC      STATUS+0, 2
	GOTO       L__Interrupt13
;electronique_interface_midi_010_16f628.mpas,134 :: 		ArrRxBuf[iRxTail] := iRxData;
	MOVF       _iRxTail+0, 0
	ADDLW      _ArrRxBuf+0
	MOVWF      FSR
	MOVF       _iRxData+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_010_16f628.mpas,135 :: 		Inc(iRxTail);
	INCF       _iRxTail+0, 1
;electronique_interface_midi_010_16f628.mpas,136 :: 		if iRxTail > cRxBufSize then // reach buffer end, return to buffer start
	MOVF       _iRxTail+0, 0
	SUBLW      64
	BTFSC      STATUS+0, 0
	GOTO       L__Interrupt16
;electronique_interface_midi_010_16f628.mpas,137 :: 		iRxTail := 0;
	CLRF       _iRxTail+0
L__Interrupt16:
;electronique_interface_midi_010_16f628.mpas,138 :: 		bRxBufEmpty := false;        // flag that some data have been received
	CLRF       _bRxBufEmpty+0
;electronique_interface_midi_010_16f628.mpas,139 :: 		if iRxTail = iRxHead then
	MOVF       _iRxTail+0, 0
	XORWF      _iRxHead+0, 0
	BTFSS      STATUS+0, 2
	GOTO       L__Interrupt19
;electronique_interface_midi_010_16f628.mpas,140 :: 		bRxBufFull := true;
	MOVLW      255
	MOVWF      _bRxBufFull+0
L__Interrupt19:
;electronique_interface_midi_010_16f628.mpas,141 :: 		end;
L__Interrupt13:
;electronique_interface_midi_010_16f628.mpas,142 :: 		end;
L__Interrupt10:
;electronique_interface_midi_010_16f628.mpas,143 :: 		end
	GOTO       L__Interrupt8
;electronique_interface_midi_010_16f628.mpas,144 :: 		else
L__Interrupt7:
;electronique_interface_midi_010_16f628.mpas,148 :: 		Clearbit(RCSTA, CREN);
	BCF        RCSTA+0, 4
;electronique_interface_midi_010_16f628.mpas,149 :: 		Setbit(RCSTA, CREN);
	BSF        RCSTA+0, 4
;electronique_interface_midi_010_16f628.mpas,150 :: 		end;
L__Interrupt8:
;electronique_interface_midi_010_16f628.mpas,151 :: 		end;
L__Interrupt4:
;electronique_interface_midi_010_16f628.mpas,152 :: 		end;
L_end_Interrupt:
L__Interrupt148:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_Midi_DataReceived:

;electronique_interface_midi_010_16f628.mpas,155 :: 		begin
;electronique_interface_midi_010_16f628.mpas,157 :: 		result := (not bRxBufEmpty);
	COMF       _bRxBufEmpty+0, 0
	MOVWF      R1+0
;electronique_interface_midi_010_16f628.mpas,159 :: 		end;
	MOVF       R1+0, 0
	MOVWF      R0+0
L_end_Midi_DataReceived:
	RETURN
; end of _Midi_DataReceived

_Midi_MsgReceived:

;electronique_interface_midi_010_16f628.mpas,165 :: 		begin
;electronique_interface_midi_010_16f628.mpas,171 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) or
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R2+0
;electronique_interface_midi_010_16f628.mpas,172 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_Off_Ch_1));
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	IORWF      R2+0, 0
	MOVWF      R1+0
;electronique_interface_midi_010_16f628.mpas,174 :: 		bFullMsgReceived := (iRxByteCount = 3);
	MOVF       _iRxByteCount+0, 0
	XORLW      3
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
;electronique_interface_midi_010_16f628.mpas,176 :: 		result := (bNoteDetected and bFullMsgReceived);
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R3+0
;electronique_interface_midi_010_16f628.mpas,178 :: 		end;
	MOVF       R3+0, 0
	MOVWF      R0+0
L_end_Midi_MsgReceived:
	RETURN
; end of _Midi_MsgReceived

_Midi_RxReadByte:

;electronique_interface_midi_010_16f628.mpas,184 :: 		begin
;electronique_interface_midi_010_16f628.mpas,186 :: 		Rk := 0;
	CLRF       R4+0
;electronique_interface_midi_010_16f628.mpas,188 :: 		if bRxBufEmpty = false then
	MOVF       _bRxBufEmpty+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Midi_RxReadByte25
;electronique_interface_midi_010_16f628.mpas,191 :: 		Rk := ArrRxBuf[iRxHead];
	MOVF       _iRxHead+0, 0
	ADDLW      _ArrRxBuf+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      R4+0
;electronique_interface_midi_010_16f628.mpas,195 :: 		((Rk and $F0) = cMIDI_Note_On_Ch_1) or
	MOVLW      240
	ANDWF      R0+0, 0
	MOVWF      R2+0
	MOVF       R2+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_010_16f628.mpas,196 :: 		((Rk and $F0) = cMIDI_Note_Off_Ch_1));
	MOVF       R2+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	IORWF      R0+0, 1
;electronique_interface_midi_010_16f628.mpas,197 :: 		if bNoteDetected then
	BTFSC      STATUS+0, 2
	GOTO       L__Midi_RxReadByte28
;electronique_interface_midi_010_16f628.mpas,199 :: 		iRxByteCount := 1;
	MOVLW      1
	MOVWF      _iRxByteCount+0
;electronique_interface_midi_010_16f628.mpas,200 :: 		ArrRxData[iRxByteCount] := Rk;
	CLRF       R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       R4+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_010_16f628.mpas,201 :: 		end
	GOTO       L__Midi_RxReadByte29
;electronique_interface_midi_010_16f628.mpas,202 :: 		else
L__Midi_RxReadByte28:
;electronique_interface_midi_010_16f628.mpas,204 :: 		inc(iRxByteCount);
	INCF       _iRxByteCount+0, 1
;electronique_interface_midi_010_16f628.mpas,205 :: 		ArrRxData[iRxByteCount] := Rk;
	DECF       _iRxByteCount+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	MOVF       R4+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_010_16f628.mpas,206 :: 		end;
L__Midi_RxReadByte29:
;electronique_interface_midi_010_16f628.mpas,208 :: 		ArrRxBuf[iRxHead] := 0; // clear value that has been read (not really needed ?)
	MOVF       _iRxHead+0, 0
	ADDLW      _ArrRxBuf+0
	MOVWF      FSR
	CLRF       INDF+0
;electronique_interface_midi_010_16f628.mpas,209 :: 		inc(iRxHead);
	INCF       _iRxHead+0, 1
;electronique_interface_midi_010_16f628.mpas,210 :: 		if iRxHead > cRxBufSize then
	MOVF       _iRxHead+0, 0
	SUBLW      64
	BTFSC      STATUS+0, 0
	GOTO       L__Midi_RxReadByte31
;electronique_interface_midi_010_16f628.mpas,211 :: 		iRxHead := 0;
	CLRF       _iRxHead+0
L__Midi_RxReadByte31:
;electronique_interface_midi_010_16f628.mpas,212 :: 		bRxBufEmpty := (iRxHead = iRxTail); // all received bytes have been read
	MOVF       _iRxHead+0, 0
	XORWF      _iRxTail+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      _bRxBufEmpty+0
;electronique_interface_midi_010_16f628.mpas,214 :: 		end;
L__Midi_RxReadByte25:
;electronique_interface_midi_010_16f628.mpas,215 :: 		Result := Rk;
	MOVF       R4+0, 0
	MOVWF      R3+0
;electronique_interface_midi_010_16f628.mpas,216 :: 		end;
	MOVF       R3+0, 0
	MOVWF      R0+0
L_end_Midi_RxReadByte:
	RETURN
; end of _Midi_RxReadByte

_Rx_Reset:

;electronique_interface_midi_010_16f628.mpas,219 :: 		begin
;electronique_interface_midi_010_16f628.mpas,220 :: 		for i := 1 to 3 do
	MOVLW      1
	MOVWF      _i+0
L__Rx_Reset35:
;electronique_interface_midi_010_16f628.mpas,221 :: 		ArrRxData[i] := $00;
	DECF       _i+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ADDLW      _ArrRxData+0
	MOVWF      FSR
	CLRF       INDF+0
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__Rx_Reset38
	INCF       _i+0, 1
	GOTO       L__Rx_Reset35
L__Rx_Reset38:
;electronique_interface_midi_010_16f628.mpas,222 :: 		end;
L_end_Rx_Reset:
	RETURN
; end of _Rx_Reset

_Main_Welcome:

;electronique_interface_midi_010_16f628.mpas,225 :: 		begin
;electronique_interface_midi_010_16f628.mpas,226 :: 		Out_Led := 0;  // Led on
	BCF        RA4_bit+0, 4
;electronique_interface_midi_010_16f628.mpas,227 :: 		Delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      4
	MOVWF      R12+0
	MOVLW      186
	MOVWF      R13+0
L__Main_Welcome40:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome40
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome40
	DECFSZ     R11+0, 1
	GOTO       L__Main_Welcome40
	NOP
;electronique_interface_midi_010_16f628.mpas,228 :: 		Out_Led := 1;  // Led off
	BSF        RA4_bit+0, 4
;electronique_interface_midi_010_16f628.mpas,229 :: 		end;
L_end_Main_Welcome:
	RETURN
; end of _Main_Welcome

_Midi_GetChannelSetting:

;electronique_interface_midi_010_16f628.mpas,232 :: 		begin
;electronique_interface_midi_010_16f628.mpas,233 :: 		iMidiChannelSet := 0; // hard fixed at the moment
	CLRF       _iMidiChannelSet+0
;electronique_interface_midi_010_16f628.mpas,241 :: 		end;
L_end_Midi_GetChannelSetting:
	RETURN
; end of _Midi_GetChannelSetting

_DigitalPot_CS_Set:

;electronique_interface_midi_010_16f628.mpas,244 :: 		begin
;electronique_interface_midi_010_16f628.mpas,246 :: 		0 : Out_DigPot1_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set46
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set156
	BCF        RA2_bit+0, 2
	GOTO       L__DigitalPot_CS_Set157
L__DigitalPot_CS_Set156:
	BSF        RA2_bit+0, 2
L__DigitalPot_CS_Set157:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set46:
;electronique_interface_midi_010_16f628.mpas,247 :: 		1 : Out_DigPot2_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set49
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set158
	BCF        RA3_bit+0, 3
	GOTO       L__DigitalPot_CS_Set159
L__DigitalPot_CS_Set158:
	BSF        RA3_bit+0, 3
L__DigitalPot_CS_Set159:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set49:
;electronique_interface_midi_010_16f628.mpas,248 :: 		2 : Out_DigPot3_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set52
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set160
	BCF        RB0_bit+0, 0
	GOTO       L__DigitalPot_CS_Set161
L__DigitalPot_CS_Set160:
	BSF        RB0_bit+0, 0
L__DigitalPot_CS_Set161:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set52:
;electronique_interface_midi_010_16f628.mpas,249 :: 		3 : Out_DigPot4_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set55
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set162
	BCF        RB3_bit+0, 3
	GOTO       L__DigitalPot_CS_Set163
L__DigitalPot_CS_Set162:
	BSF        RB3_bit+0, 3
L__DigitalPot_CS_Set163:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set55:
;electronique_interface_midi_010_16f628.mpas,250 :: 		4 : Out_DigPot5_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set58
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set164
	BCF        RB4_bit+0, 4
	GOTO       L__DigitalPot_CS_Set165
L__DigitalPot_CS_Set164:
	BSF        RB4_bit+0, 4
L__DigitalPot_CS_Set165:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set58:
;electronique_interface_midi_010_16f628.mpas,251 :: 		5 : Out_DigPot6_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set61
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set166
	BCF        RB5_bit+0, 5
	GOTO       L__DigitalPot_CS_Set167
L__DigitalPot_CS_Set166:
	BSF        RB5_bit+0, 5
L__DigitalPot_CS_Set167:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set61:
;electronique_interface_midi_010_16f628.mpas,252 :: 		6 : Out_DigPot7_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set64
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set168
	BCF        RB6_bit+0, 6
	GOTO       L__DigitalPot_CS_Set169
L__DigitalPot_CS_Set168:
	BSF        RB6_bit+0, 6
L__DigitalPot_CS_Set169:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set64:
;electronique_interface_midi_010_16f628.mpas,253 :: 		7 : Out_DigPot8_CS := bState;
	MOVF       FARG_DigitalPot_CS_Set_idx+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__DigitalPot_CS_Set67
	BTFSC      FARG_DigitalPot_CS_Set_bState+0, 0
	GOTO       L__DigitalPot_CS_Set170
	BCF        RB7_bit+0, 7
	GOTO       L__DigitalPot_CS_Set171
L__DigitalPot_CS_Set170:
	BSF        RB7_bit+0, 7
L__DigitalPot_CS_Set171:
	GOTO       L__DigitalPot_CS_Set43
L__DigitalPot_CS_Set67:
L__DigitalPot_CS_Set43:
;electronique_interface_midi_010_16f628.mpas,255 :: 		end;
L_end_DigitalPot_CS_Set:
	RETURN
; end of _DigitalPot_CS_Set

_MCP41xxx_Set:

;electronique_interface_midi_010_16f628.mpas,260 :: 		begin
;electronique_interface_midi_010_16f628.mpas,261 :: 		iCmdToSend  := %00010001;
	MOVLW      17
	MOVWF      MCP41xxx_Set_iCmdToSend+0
;electronique_interface_midi_010_16f628.mpas,263 :: 		$01 : iDataToSend := $00;      // min
	MOVF       FARG_MCP41xxx_Set_val+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__MCP41xxx_Set72
	CLRF       MCP41xxx_Set_iDataToSend+0
	GOTO       L__MCP41xxx_Set69
L__MCP41xxx_Set72:
;electronique_interface_midi_010_16f628.mpas,264 :: 		$7F : iDataToSend := $FF       // max
	MOVF       FARG_MCP41xxx_Set_val+0, 0
	XORLW      127
	BTFSS      STATUS+0, 2
	GOTO       L__MCP41xxx_Set75
	MOVLW      255
	MOVWF      MCP41xxx_Set_iDataToSend+0
;electronique_interface_midi_010_16f628.mpas,265 :: 		else iDataToSend := val * 2; // MIDI vel 2..126, pot value 4..252
	GOTO       L__MCP41xxx_Set69
L__MCP41xxx_Set75:
	MOVF       FARG_MCP41xxx_Set_val+0, 0
	MOVWF      MCP41xxx_Set_iDataToSend+0
	RLF        MCP41xxx_Set_iDataToSend+0, 1
	BCF        MCP41xxx_Set_iDataToSend+0, 0
L__MCP41xxx_Set69:
;electronique_interface_midi_010_16f628.mpas,269 :: 		DigitalPot_CS_Set(idx, false);
	MOVF       FARG_MCP41xxx_Set_idx+0, 0
	MOVWF      FARG_DigitalPot_CS_Set_idx+0
	CLRF       FARG_DigitalPot_CS_Set_bState+0
	CALL       _DigitalPot_CS_Set+0
;electronique_interface_midi_010_16f628.mpas,274 :: 		for i := 7 downto 0 do
	MOVLW      7
	MOVWF      _i+0
L__MCP41xxx_Set77:
;electronique_interface_midi_010_16f628.mpas,276 :: 		Out_Spi_Data := iCmdToSend.i;
	MOVF       _i+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__MCP41xxx_Set173:
	BTFSC      STATUS+0, 2
	GOTO       L__MCP41xxx_Set174
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__MCP41xxx_Set173
L__MCP41xxx_Set174:
	MOVF       R0+0, 0
	ANDWF      MCP41xxx_Set_iCmdToSend+0, 0
	MOVWF      R2+0
	CLRF       R1+0
	MOVF       R2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__MCP41xxx_Set81
	MOVLW      1
	MOVWF      R1+0
L__MCP41xxx_Set81:
	BTFSC      R1+0, 0
	GOTO       L__MCP41xxx_Set175
	BCF        RA1_bit+0, 1
	GOTO       L__MCP41xxx_Set176
L__MCP41xxx_Set175:
	BSF        RA1_bit+0, 1
L__MCP41xxx_Set176:
;electronique_interface_midi_010_16f628.mpas,277 :: 		Out_Spi_Clock := 1;
	BSF        RA0_bit+0, 0
;electronique_interface_midi_010_16f628.mpas,278 :: 		Delay_us(20);
	MOVLW      13
	MOVWF      R13+0
L__MCP41xxx_Set82:
	DECFSZ     R13+0, 1
	GOTO       L__MCP41xxx_Set82
;electronique_interface_midi_010_16f628.mpas,279 :: 		Out_Spi_Clock := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_010_16f628.mpas,280 :: 		Delay_us(20);
	MOVLW      13
	MOVWF      R13+0
L__MCP41xxx_Set83:
	DECFSZ     R13+0, 1
	GOTO       L__MCP41xxx_Set83
;electronique_interface_midi_010_16f628.mpas,281 :: 		end;
	MOVF       _i+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__MCP41xxx_Set80
	DECF       _i+0, 1
	GOTO       L__MCP41xxx_Set77
L__MCP41xxx_Set80:
;electronique_interface_midi_010_16f628.mpas,282 :: 		Out_Spi_Data := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_010_16f628.mpas,283 :: 		Delay_us(20);
	MOVLW      13
	MOVWF      R13+0
L__MCP41xxx_Set84:
	DECFSZ     R13+0, 1
	GOTO       L__MCP41xxx_Set84
;electronique_interface_midi_010_16f628.mpas,286 :: 		for i := 7 downto 0 do
	MOVLW      7
	MOVWF      _i+0
L__MCP41xxx_Set86:
;electronique_interface_midi_010_16f628.mpas,288 :: 		Out_Spi_Data := iDataToSend.i;
	MOVF       _i+0, 0
	MOVWF      R1+0
	MOVLW      1
	MOVWF      R0+0
	MOVF       R1+0, 0
L__MCP41xxx_Set177:
	BTFSC      STATUS+0, 2
	GOTO       L__MCP41xxx_Set178
	RLF        R0+0, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__MCP41xxx_Set177
L__MCP41xxx_Set178:
	MOVF       R0+0, 0
	ANDWF      MCP41xxx_Set_iDataToSend+0, 0
	MOVWF      R2+0
	CLRF       R1+0
	MOVF       R2+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__MCP41xxx_Set90
	MOVLW      1
	MOVWF      R1+0
L__MCP41xxx_Set90:
	BTFSC      R1+0, 0
	GOTO       L__MCP41xxx_Set179
	BCF        RA1_bit+0, 1
	GOTO       L__MCP41xxx_Set180
L__MCP41xxx_Set179:
	BSF        RA1_bit+0, 1
L__MCP41xxx_Set180:
;electronique_interface_midi_010_16f628.mpas,289 :: 		Out_Spi_Clock := 1;
	BSF        RA0_bit+0, 0
;electronique_interface_midi_010_16f628.mpas,290 :: 		Delay_us(20);
	MOVLW      13
	MOVWF      R13+0
L__MCP41xxx_Set91:
	DECFSZ     R13+0, 1
	GOTO       L__MCP41xxx_Set91
;electronique_interface_midi_010_16f628.mpas,291 :: 		Out_Spi_Clock := 0;
	BCF        RA0_bit+0, 0
;electronique_interface_midi_010_16f628.mpas,292 :: 		Delay_us(20);
	MOVLW      13
	MOVWF      R13+0
L__MCP41xxx_Set92:
	DECFSZ     R13+0, 1
	GOTO       L__MCP41xxx_Set92
;electronique_interface_midi_010_16f628.mpas,293 :: 		end;
	MOVF       _i+0, 0
	XORLW      0
	BTFSC      STATUS+0, 2
	GOTO       L__MCP41xxx_Set89
	DECF       _i+0, 1
	GOTO       L__MCP41xxx_Set86
L__MCP41xxx_Set89:
;electronique_interface_midi_010_16f628.mpas,294 :: 		Out_Spi_Data := 0;
	BCF        RA1_bit+0, 1
;electronique_interface_midi_010_16f628.mpas,295 :: 		Delay_us(20);
	MOVLW      13
	MOVWF      R13+0
L__MCP41xxx_Set93:
	DECFSZ     R13+0, 1
	GOTO       L__MCP41xxx_Set93
;electronique_interface_midi_010_16f628.mpas,298 :: 		DigitalPot_CS_Set(idx, true);
	MOVF       FARG_MCP41xxx_Set_idx+0, 0
	MOVWF      FARG_DigitalPot_CS_Set_idx+0
	MOVLW      255
	MOVWF      FARG_DigitalPot_CS_Set_bState+0
	CALL       _DigitalPot_CS_Set+0
;electronique_interface_midi_010_16f628.mpas,299 :: 		end;
L_end_MCP41xxx_Set:
	RETURN
; end of _MCP41xxx_Set

_DigitalPot_Set:

;electronique_interface_midi_010_16f628.mpas,302 :: 		begin
;electronique_interface_midi_010_16f628.mpas,303 :: 		MCP41xxx_Set(idx, val);
	MOVF       FARG_DigitalPot_Set_idx+0, 0
	MOVWF      FARG_MCP41xxx_Set_idx+0
	MOVF       FARG_DigitalPot_Set_val+0, 0
	MOVWF      FARG_MCP41xxx_Set_val+0
	CALL       _MCP41xxx_Set+0
;electronique_interface_midi_010_16f628.mpas,304 :: 		end;
L_end_DigitalPot_Set:
	RETURN
; end of _DigitalPot_Set

_DigitalPot_Init:

;electronique_interface_midi_010_16f628.mpas,307 :: 		begin
;electronique_interface_midi_010_16f628.mpas,308 :: 		for i := 0 to 7 do
	CLRF       _i+0
L__DigitalPot_Init97:
;electronique_interface_midi_010_16f628.mpas,309 :: 		DigitalPot_CS_Set(i, true);
	MOVF       _i+0, 0
	MOVWF      FARG_DigitalPot_CS_Set_idx+0
	MOVLW      255
	MOVWF      FARG_DigitalPot_CS_Set_bState+0
	CALL       _DigitalPot_CS_Set+0
	MOVF       _i+0, 0
	XORLW      7
	BTFSC      STATUS+0, 2
	GOTO       L__DigitalPot_Init100
	INCF       _i+0, 1
	GOTO       L__DigitalPot_Init97
L__DigitalPot_Init100:
;electronique_interface_midi_010_16f628.mpas,310 :: 		end;
L_end_DigitalPot_Init:
	RETURN
; end of _DigitalPot_Init

_main:

;electronique_interface_midi_010_16f628.mpas,313 :: 		begin
;electronique_interface_midi_010_16f628.mpas,314 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_interface_midi_010_16f628.mpas,315 :: 		DigitalPot_Init;
	CALL       _DigitalPot_Init+0
;electronique_interface_midi_010_16f628.mpas,318 :: 		Main_Welcome;
	CALL       _Main_Welcome+0
;electronique_interface_midi_010_16f628.mpas,321 :: 		Midi_GetChannelSetting;
	CALL       _Midi_GetChannelSetting+0
;electronique_interface_midi_010_16f628.mpas,324 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_010_16f628.mpas,325 :: 		iRxByteCount := 0;
	CLRF       _iRxByteCount+0
;electronique_interface_midi_010_16f628.mpas,327 :: 		while true do
L__main103:
;electronique_interface_midi_010_16f628.mpas,331 :: 		if Midi_DataReceived then
	CALL       _Midi_DataReceived+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main108
;electronique_interface_midi_010_16f628.mpas,335 :: 		Midi_RxReadByte;
	CALL       _Midi_RxReadByte+0
;electronique_interface_midi_010_16f628.mpas,338 :: 		if Midi_MsgReceived then
	CALL       _Midi_MsgReceived+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main111
;electronique_interface_midi_010_16f628.mpas,343 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) and
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_010_16f628.mpas,344 :: 		(ArrRxData[3] > $00));
	MOVF       _ArrRxData+2, 0
	SUBLW      0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R3+0
	MOVF       R3+0, 0
	MOVWF      _bNoteOn+0
;electronique_interface_midi_010_16f628.mpas,347 :: 		(((ArrRxData[1] and $F0) = cMIDI_Note_On_Ch_1) and
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	XORLW      144
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_010_16f628.mpas,348 :: 		(ArrRxData[3] = $00)) or
	MOVF       _ArrRxData+2, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 0
	MOVWF      R2+0
;electronique_interface_midi_010_16f628.mpas,349 :: 		((ArrRxData[1] and $F0) = cMIDI_Note_Off_Ch_1));
	MOVLW      240
	ANDWF      _ArrRxData+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      128
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _bNoteOff+0
;electronique_interface_midi_010_16f628.mpas,352 :: 		iMidiChannelRx := ArrRxData[1] and $0F;
	MOVLW      15
	ANDWF      _ArrRxData+0, 0
	MOVWF      _iMidiChannelRx+0
;electronique_interface_midi_010_16f628.mpas,355 :: 		if (bNoteOn or bNoteOff) then
	MOVF       R3+0, 0
	IORWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main114
;electronique_interface_midi_010_16f628.mpas,357 :: 		Out_Led := 0;  // Led_Rx on
	BCF        RA4_bit+0, 4
;electronique_interface_midi_010_16f628.mpas,358 :: 		if bNoteOn and (iMidiChannelRx = iMidiChannelSet) then
	MOVF       _iMidiChannelRx+0, 0
	XORWF      _iMidiChannelSet+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       _bNoteOn+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__main117
;electronique_interface_midi_010_16f628.mpas,361 :: 		cMIDI_Note_Do3  : DigitalPot_Set(0, ArrRxData[3]);
	MOVF       _ArrRxData+1, 0
	XORLW      60
	BTFSS      STATUS+0, 2
	GOTO       L__main122
	CLRF       FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
	GOTO       L__main119
L__main122:
;electronique_interface_midi_010_16f628.mpas,362 :: 		cMIDI_Note_Re3  : DigitalPot_Set(1, ArrRxData[3]);
	MOVF       _ArrRxData+1, 0
	XORLW      62
	BTFSS      STATUS+0, 2
	GOTO       L__main125
	MOVLW      1
	MOVWF      FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
	GOTO       L__main119
L__main125:
;electronique_interface_midi_010_16f628.mpas,363 :: 		cMIDI_Note_Mi3  : DigitalPot_Set(2, ArrRxData[3]);
	MOVF       _ArrRxData+1, 0
	XORLW      64
	BTFSS      STATUS+0, 2
	GOTO       L__main128
	MOVLW      2
	MOVWF      FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
	GOTO       L__main119
L__main128:
;electronique_interface_midi_010_16f628.mpas,364 :: 		cMIDI_Note_Fa3  : DigitalPot_Set(3, ArrRxData[3]);
	MOVF       _ArrRxData+1, 0
	XORLW      65
	BTFSS      STATUS+0, 2
	GOTO       L__main131
	MOVLW      3
	MOVWF      FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
	GOTO       L__main119
L__main131:
;electronique_interface_midi_010_16f628.mpas,365 :: 		cMIDI_Note_Sol3 : DigitalPot_Set(4, ArrRxData[3]);
	MOVF       _ArrRxData+1, 0
	XORLW      67
	BTFSS      STATUS+0, 2
	GOTO       L__main134
	MOVLW      4
	MOVWF      FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
	GOTO       L__main119
L__main134:
;electronique_interface_midi_010_16f628.mpas,366 :: 		cMIDI_Note_La3  : DigitalPot_Set(5, ArrRxData[3]);
	MOVF       _ArrRxData+1, 0
	XORLW      69
	BTFSS      STATUS+0, 2
	GOTO       L__main137
	MOVLW      5
	MOVWF      FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
	GOTO       L__main119
L__main137:
;electronique_interface_midi_010_16f628.mpas,367 :: 		cMIDI_Note_Si3  : DigitalPot_Set(6, ArrRxData[3]);
	MOVF       _ArrRxData+1, 0
	XORLW      71
	BTFSS      STATUS+0, 2
	GOTO       L__main140
	MOVLW      6
	MOVWF      FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
	GOTO       L__main119
L__main140:
;electronique_interface_midi_010_16f628.mpas,368 :: 		cMIDI_Note_Do4  : DigitalPot_Set(7, ArrRxData[3])
	MOVF       _ArrRxData+1, 0
	XORLW      72
	BTFSS      STATUS+0, 2
	GOTO       L__main143
	MOVLW      7
	MOVWF      FARG_DigitalPot_Set_idx+0
	MOVF       _ArrRxData+2, 0
	MOVWF      FARG_DigitalPot_Set_val+0
	CALL       _DigitalPot_Set+0
;electronique_interface_midi_010_16f628.mpas,369 :: 		else
	GOTO       L__main119
L__main143:
;electronique_interface_midi_010_16f628.mpas,370 :: 		delay_ms(2);  // let LED_Rx light on enought time to see it
	MOVLW      6
	MOVWF      R12+0
	MOVLW      48
	MOVWF      R13+0
L__main144:
	DECFSZ     R13+0, 1
	GOTO       L__main144
	DECFSZ     R12+0, 1
	GOTO       L__main144
	NOP
L__main119:
;electronique_interface_midi_010_16f628.mpas,372 :: 		Out_Led := 1;  // Led_Rx off
	BSF        RA4_bit+0, 4
;electronique_interface_midi_010_16f628.mpas,373 :: 		end
	GOTO       L__main118
;electronique_interface_midi_010_16f628.mpas,374 :: 		else
L__main117:
;electronique_interface_midi_010_16f628.mpas,376 :: 		delay_ms(2);  // let LED_Rx light on enought time to see it
	MOVLW      6
	MOVWF      R12+0
	MOVLW      48
	MOVWF      R13+0
L__main145:
	DECFSZ     R13+0, 1
	GOTO       L__main145
	DECFSZ     R12+0, 1
	GOTO       L__main145
	NOP
;electronique_interface_midi_010_16f628.mpas,377 :: 		Out_Led := 1;  // Led_Rx off
	BSF        RA4_bit+0, 4
;electronique_interface_midi_010_16f628.mpas,378 :: 		end;
L__main118:
;electronique_interface_midi_010_16f628.mpas,381 :: 		Rx_Reset;
	CALL       _Rx_Reset+0
;electronique_interface_midi_010_16f628.mpas,383 :: 		end;
L__main114:
;electronique_interface_midi_010_16f628.mpas,384 :: 		end;
L__main111:
;electronique_interface_midi_010_16f628.mpas,385 :: 		end;
L__main108:
;electronique_interface_midi_010_16f628.mpas,388 :: 		end;
	GOTO       L__main103
;electronique_interface_midi_010_16f628.mpas,390 :: 		end.
L_end_main:
	GOTO       $+0
; end of _main
